# It is unclear whether upstream is authorized to redistribute the
# firmware, so we should not have cachix mirror them until that is
# clarified

{ lib
, stdenv
, fetchurl
}:
let
  base_url = "https://drive.google.com/uc?export=download&id=";
  urls_to_fetch = {
    # these URLs were transcribed from `em100/curl.c`
    "firmware.tar.xz" = { url = "${base_url}1UmzGZbRkF9duwTLPi467EyfIZ6EhnMKA"; hash = "sha256-h8PfNWyrf6BqJoR8FlQJqO3u7IMbQ8Y3etEGrcUMYwM="; };
    "configs.tar.xz"  = { url = "${base_url}19jT6kNYV1TE6WNx6lUkgH0TYyKbxXcd4"; hash = "sha256-cxWb4Ngg6CuA6QmNIsVfZ6dmCckRnscLISNmAmjUYJk="; };
    "VERSION"         = { url = "${base_url}1YC755W_c4nRN4qVgosegFrvfyWllqb0b"; hash = "sha256-jdljIpO/gRmrCMsYyPdbl6DE1doI99zoPAsmZZCjToI="; };
  };
in
stdenv.mkDerivation {
  name = "dediprog-em100-firmware";
  version = "unstable-2022may02-86631c9";   # upstream does not appear to have formal releases

  srcs = lib.mapAttrs (k: v: fetchurl {
    url = v.url;
    hash = v.hash;
  }) urls_to_fetch;

  dontBuild = true;

  installPhase = ''
  '';

  meta = {
    sourceProvenance = with lib.sourceTypes; [ binaryFirmware ];
    license = lib.licenses.unfree; # redistribution situation is unclear
  }
}
